SystemOrganization addCategory: #'Ejercicio-Metamodelo'!

Object subclass: #ClassSurfer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ejercicio-Metamodelo'!

!ClassSurfer class methodsFor: 'as yet unclassified' stamp: 'aadas 6/19/2013 20:41'!
searchMissingImplementors: aClass 

"	| methods |
	methods := aClass methodDictionary.
	iteratorLimit := methods keys size.
	iterator := 0.
	methodArray := methods asArray .
	resultCollection := 
	
	( iterator < iteratorLimit  )  whileTrue: [ self collectMissingImplementorsOfClass: aClass forMethod: (methodArray)  on: methodArray  ]."! !

!ClassSurfer methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 19:16'!
inspectMethod: aMethod in: aClass 
	self halt.
	(self is: aMethod implementedIn: aClass) 
	ifTrue: [ ^ Set new.	] 
	ifFalse:[
			(aClass subclasses isEmpty)
			 ifTrue:	[ ^(Set new) add: aClass. ]
			
			ifFalse: [ self searchMethod: aMethod in: aClass. ]
			
			]! !

!ClassSurfer methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 17:20'!
is: aMethod implementedIn: aClass 
	| isAnUnimplementedMethod isInMethodDictionary |
	isAnUnimplementedMethod := (self unimplementedMethods: aClass) includes: aMethod.
	isInMethodDictionary := (aClass methodDictionary includesKey: aMethod).
	^(isAnUnimplementedMethod not) and: isInMethodDictionary.! !

!ClassSurfer methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 19:15'!
searchMethod: aMethod in: aClass 
	
	| subclasses |
	self halt.
	subclasses := aClass subclasses asSet.
	^ subclasses collect: [ :each | self inspectMethod: aMethod in: each. ].! !

!ClassSurfer methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 19:15'!
searchMissingImplementors: aClass
	| missingImplementors result |

	missingImplementors := Set new.
	
	self halt.
	result := (self unimplementedMethods: aClass) collect: [ :each | self searchMethod: each in: aClass. ] into: missingImplementors.  
	^ self superUnion: result.! !

!ClassSurfer methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 19:16'!
superUnion: aSet
	| result aSet2 |
	
	result := Set new.
	aSet collect: [ :each | result := result union: each ].
	
	self halt.

	aSet2 := Set new.
	aSet2 add:  Set new.
	
	^result \ aSet2.! !

!ClassSurfer methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 18:51'!
unimplementedMethods: aClass

	 | unimplementedMethods methods |
	unimplementedMethods := OrderedCollection new.
	methods := aClass methodDictionary keys.
	unimplementedMethods  := methods select: [ :m | (aClass methodNamed: m) isAbstract  ].
	^unimplementedMethods asOrderedCollection.
	! !

Object subclass: #ClassWithTwoAbstractMethodsOutOfThree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ejercicio-Metamodelo'!

!ClassWithTwoAbstractMethodsOutOfThree methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 16:12'!
abstractMethod1
^self subclassResponsibility.! !

!ClassWithTwoAbstractMethodsOutOfThree methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 16:12'!
abstractMethod2
^self subclassResponsibility.! !

!ClassWithTwoAbstractMethodsOutOfThree methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 16:12'!
method3
^true! !

Object subclass: #SimpleHierarchyClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ejercicio-Metamodelo'!

!SimpleHierarchyClass methodsFor: 'as yet unclassified' stamp: 'aadas 6/19/2013 20:05'!
message1
	^self subclassResponsibility.! !

!SimpleHierarchyClass methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 18:30'!
message2
	^self subclassResponsibility.! !

SimpleHierarchyClass subclass: #SimpleHierarchySubClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ejercicio-Metamodelo'!

!SimpleHierarchySubClass methodsFor: 'as yet unclassified' stamp: 'aadas 6/19/2013 20:05'!
message1
	^true.! !

TestCase subclass: #MissingImplementors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ejercicio-Metamodelo'!

!MissingImplementors methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 16:01'!
test01abstractMethodShouldReturnTrueIfAbstract
	|  aCompiledMethod methods |
	methods := SimpleHierarchyClass methodDictionary.
	aCompiledMethod := SimpleHierarchyClass methodNamed: (methods keys at: 1).
	self assert: (aCompiledMethod isAbstract).! !

!MissingImplementors methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 16:55'!
test02whenWeAskForTheAbstractMethodsOfClassXXXitShouldReturnTwoMethods

	| unimplementedMethods aClassSurfer methods |
	aClassSurfer := ClassSurfer new.
	unimplementedMethods := aClassSurfer unimplementedMethods: ClassWithTwoAbstractMethodsOutOfThree. 
	methods := OrderedCollection new.
	methods add: #abstractMethod1.
	methods add: #abstractMethod2.
	
	self assert: methods = unimplementedMethods.
"
 	| methods missingImplementors |
	aClassSurfer := ClassSurfer new.
	missingImplementors := ClassSurfer searchMissingImplementors: SimpleHierarchyClass.
	self assert: missingImplementors isEmpty."

	! !

!MissingImplementors methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 17:30'!
test03method3ShouldBeImplementedAndTheRestShouldBeAbstract

	| aClassSurfer |
	aClassSurfer := ClassSurfer new.

	self assert: (aClassSurfer is: #method3 implementedIn: ClassWithTwoAbstractMethodsOutOfThree).
	self deny: (aClassSurfer is: #abstractMethod1 implementedIn: ClassWithTwoAbstractMethodsOutOfThree).
	self deny: (aClassSurfer is: #abstractMethod2 implementedIn: ClassWithTwoAbstractMethodsOutOfThree).

	! !

!MissingImplementors methodsFor: 'as yet unclassified' stamp: 'tuvieja 6/23/2013 17:39'!
test04XXX

	| missingImplementors aClassSurfer |
	aClassSurfer := ClassSurfer new.
	missingImplementors := aClassSurfer searchMissingImplementors: SimpleHierarchyClass.
	self assert: missingImplementors isEmpty.! !
